<template>
  <card>
    <b-row align-v="center">
      <b-tabs fill style="padding: 0 20px;">
        <b-tab active>
          <template v-slot:title v-if="!$isTemporal">
            <i class="ni ni-cloud-upload-96 mr-2"></i> Adjuntar prescripciones
          </template>
          <template v-slot:title v-else>
            <i class="ni ni-cloud-upload-96 mr-2"></i> Prescripciones
          </template>

          <b-form @submit.prevent="uploadReceipt">
            <div class="mt-5" v-if="!$isTemporal">
              <b-row>
                <b-col lg="12">
                  <div>
                    <h4 style="color: grey">Adjuntar archivo</h4>
                  </div>
                  <b-form-file
                    v-model="upload.file"
                    :state="Boolean(upload.file)"
                    placeholder="Escoge un archivo o arrastralo hasta aquí"
                    drop-placeholder="Arrastra el archivo aquí"
                  ></b-form-file>
                </b-col>

                <b-col lg="12">
                  <div class="form-group mt-4">
                    <label
                      >Observaciones</label
                    >
                    <textarea
                      class="form-control"
                      rows="3"
                      placeholder="Ingresa observaciones que creas relevantes con respecto al uso de el medicamento"
                      v-model="upload.obs"
                    ></textarea>
                  </div>
                </b-col>

                <b-col lg="12">
                  <b-row align-h="end">
                    <base-button icon type="primary" nativeType="submit">
                      Guardar
                    </base-button>
                  </b-row>
                </b-col>
              </b-row>
            </div>

            <hr class="my-4" />

            <b-row v-for="receipt in receipts" :key="receipt._id">
              <b-col class="ml-3 mr-3" lg="1">
                <div>
                  <i class=" fas fa-3x fas fa-file-medical"></i>
                </div>
              </b-col>

              <b-col lg="3" class="mr--6">
                <div>
                  <span style="color: grey; font-weight: bold" class="small">{{receipt.file}}</span>
                </div>
              </b-col>

              <b-col lg="3" class="mt-2">
                <div class="ml-5 clickeable" @click="receipt.popover = !receipt.popover">
                  <i
                    v-b-toggle
                    v-b-popover.hover.top="'Visualizar observaciones'"
                    class="fas fa-comment-medical"
                  ></i>
                </div>
              </b-col>

              <b-col lg="2" class="mt-2">
                <b-button variant="primary" size="sm" @click="download(receipt)">Descargar</b-button>
              </b-col>

              <b-col lg="1" class="mt-2" v-if="!$isTemporal">
                <b-button variant="danger" size="sm" @click="destroy(receipt)">Eliminar</b-button>
              </b-col>
              
              <b-col lg="1" class="mb-5" v-if="!$isTemporal">
                <div class=" ml-5 mr-1 mt-1 clickeable" @click="hide(receipt)">
                  <i 
                    :class="'fas fa-2x ' + (receipt.visibilidad ? 'fa-eye' : 'fa-eye-slash')"
                  ></i>
                </div>
              </b-col>

              <b-col lg="12">
                <b-collapse v-model="receipt.popover" class="mt-2">
                  <b-card>
                    <p class="card-text">{{ receipt.observacion }}</p>
                  </b-card>
                </b-collapse>
              </b-col>
              
            </b-row>
          </b-form>
        </b-tab>
      </b-tabs>
    </b-row>
  </card>
</template>
<script>
import { userService } from "../../../services";
import { saveAs } from 'file-saver';

export default {
  data() {
    return {
      receipts: [],
      upload: {
        file: null,
        obs: ""
      }
    };
  },
  mounted(){
    this.getReceipts();
  },
  methods: {
    hide(receipt) {
      userService.changeVisibility_receipt(receipt._id).then(res => {
        this.getReceipts();
      })
    },
    download(receipt) {
      userService.getFile(receipt.file).then(res => res.blob()).then(blob => {
        saveAs(blob, receipt.file);
      }).catch(() => {
        alert("Ocurrió un error al descargar")
      })
    },
    destroy(receipt) {
      userService.deleteReceipt(receipt._id).then(res => {
        alert("OK ELIMINADO");
        this.getReceipts();
      })
    },
    uploadReceipt(){
      //Formdata para subir archivo
      var formData = new FormData();
      formData.append("file", this.upload.file);
      formData.append("observacion", this.upload.obs);

      userService.uploadReceipt(formData).then(res => {
        alert("OK SUBIDO")
        this.getReceipts();
        this.reset();
      }).catch(err => {
        alert("ERROR");
      })
    },
    getReceipts(){
      userService.getReceipts().then(res => {
        res.forEach(receipt => {
          receipt.popover = false;
        })
        this.receipts = res;
      })
    },
    reset(){
      this.upload = {
        file: null,
        obs: null
      }
    }
  }
};
</script>
<style>
.clickeable {
  cursor: pointer;
}
</style>
